<?php
  /**
   * boost install file for users
   *
   * @author Matthew McNaney <mcnaney at gmail dot com>
   * @version $Id: install.php 4279 2007-02-13 19:37:10Z matt $
   */


function users_install(&$content)
{
    translate('users');
    PHPWS_Core::initModClass('users', 'Users.php');
    PHPWS_Core::initModClass('users', 'Action.php');
    PHPWS_Core::configRequireOnce('users', 'config.php');

    if (isset($_REQUEST['module']) && $_REQUEST['module'] == 'branch') {
        Branch::loadHubDB();
        $db = new PHPWS_DB('users');
        $sql = 'select a.password, b.* from user_authorization as a, users as b where b.deity = 1 and a.username = b.username';
        $deities = $db->getAll($sql);

        if (PEAR::isError($deities)) {
            PHPWS_Error::log($deities);
            $content[] = _('Could not access hub database.');
            return FALSE;
        }
        elseif (empty($deities)) {
            $content[] = _('Could not find any hub deities.');
            translate();
            return FALSE;
        } else {
            Branch::restoreBranchDB();
            $auth_db = new PHPWS_DB('user_authorization');
            $user_db = new PHPWS_DB('users');
            foreach ($deities as $deity) {

                $auth_db->addValue('username', $deity['username']);
                $auth_db->addValue('password', $deity['password']);
                $result = $auth_db->insert();
                if (PEAR::isError($result)) {
                    PHPWS_Error::log($result);
                    $content[] = _('Unable to copy deity login to branch.');
                    continue;
                }
                unset($deity['password']);
                $user_db->addValue($deity);
                $result = $user_db->insert();
                
                if (PEAR::isError($result)) {
                    PHPWS_Error::log($result);
                    $content[] = _('Unable to copy deity users to branch.');
                    Branch::loadBranchDB();
                    return FALSE;
                }
                $auth_db->reset();
                $user_db->reset();
            }
            $content[] = _('Deity users copied to branch.');
        }

        $db = new PHPWS_DB('users_auth_scripts');
        $db->addValue('display_name', _('Local'));
        $db->addValue('filename', 'local.php');
        $authorize_id = $db->insert();
        if (PEAR::isError($authorize_id)) {
            PHPWS_Error::log($authorize_id);
            $content[] = _('Unable to create authorization script.');
            translate();
            return FALSE;
        }
        translate();
        return TRUE;
    }

    $user = new PHPWS_User;
    $content[] = '<hr />';

    
    if (isset($_POST['mod_title']) && $_POST['mod_title']=='users'){
        $result = User_Action::postUser($user);
        if (!is_array($result)) {
            $db = new PHPWS_DB('users_auth_scripts');
            $db->addValue('display_name', _('Local'));
            $db->addValue('filename', 'local.php');
            $authorize_id = $db->insert();

            $user->setDeity(TRUE);
            $user->setActive(TRUE);
            $user->setApproved(TRUE);
            $user->setAuthorize($authorize_id);
            $result = $user->save();
            if (PEAR::isError($result)) {
                return $result;
            }

            PHPWS_Settings::set('users', array('site_contact' => $user->getEmail()));
            PHPWS_Settings::save('users');
            $content[] = _('User created successfully.');
            $content[] = _('User\'s email used as contact email address.');
        } else {
            $content[] = userForm($user, $result);
            translate();
            return FALSE;
        }
    } else {
        $content[] = _('Please create a user to administrate the site.') . '<br />';
        $content[] = userForm($user);
        translate();
        return FALSE;
    }
    translate();
    return TRUE;
}


function userForm(&$user, $errors=NULL){
    PHPWS_Core::initCoreClass('Form.php');
    PHPWS_Core::initModClass('users', 'Form.php');

    translate('users');
    $form = new PHPWS_Form;


    if (isset($_REQUEST['module'])) {
        $form->addHidden('module', $_REQUEST['module']);
    } else {
        $form->addHidden('step', 3);
    }

    $form->addHidden('mod_title', 'users');
    $form->addText('username', $user->getUsername());
    $form->addText('email', $user->getEmail());
    $form->addPassword('password1');
    $form->addPassword('password2');

    $form->setLabel('username', _('Username'));
    $form->setLabel('password1', _('Password'));
    $form->setLabel('email', _('Email'));

    $form->addSubmit('submit', _('Add User'));
  
    $template = $form->getTemplate();

    if (!empty($errors))
        foreach ($errors as $tag=>$message)
            $template[$tag] = $message;

    $result = PHPWS_Template::process($template, 'users', 'forms/userForm.tpl');

    $content[] = $result;
    return implode("\n", $content);
}


?>