<?php

  /**
   * Administration interface
   *
   * @author Matthew McNaney <mcnaney at gmail dot com>
   * @version $Id: Admin.php 4337 2007-02-19 16:36:51Z matt $
   */

class Version_Admin {
    function main()
    {
        $message = $title = $content = NULL;

        if (isset($_REQUEST['command'])) {
            $command = $_REQUEST['command'];
        } else {
            $command = 'settings';
        }

        switch ($command) {
        case 'settings':
            $title = _('Version settings');
            $content = Version_Admin::settings();
            break;

        case 'post_setting':
            PHPWS_Settings::set('version', 'saved_versions', $_REQUEST['saved_versions']);
            PHPWS_Settings::save('version');
            $title = _('Version settings');
            $message = _('Settings saved.');
            $content = Version_Admin::settings();
            break;
            
        }

        $template['TITLE']   = $title;
        $template['CONTENT'] = $content;
        $template['MESSAGE'] = $message;

        Layout::add(PHPWS_ControlPanel::display(PHPWS_Template::process($template, 'version', 'main.tpl')));
    }


    function settings()
    {
        $versions[0] = _('Keep all versions');
        $versions[5] = 5;
        $versions[10] = 10;
        $versions[25] = 25;
        $versions[50] = 50;

        $version_number = PHPWS_Settings::get('version', 'saved_versions');

        $form = new PHPWS_Form;
        $form->addHidden('module', 'version');
        $form->addHidden('command', 'post_setting');
        $form->addSelect('saved_versions', $versions);
        $form->setMatch('saved_versions', $version_number);

        $form->addSubmit(_('Save'));
        $template = $form->getTemplate();

        $content = PHPWS_Template::process($template, 'version', 'settings.tpl');
        return $content;
    }

}

?>